theory Submission
  imports Defs
begin

text \<open>Your task\<close>
theorem L_eq_G:
  "L = G"
proof safe
  fix w assume "w \<in> G"
  thus "w \<in> L"
  proof induction
    case (a_b w)
    then obtain n where "w = replicate n a @ replicate n b"
      by (auto simp: L_def)
    thus ?case using a_b by (auto intro!: exI[of _ "Suc n"] simp: L_def replicate_append_same)
  qed (auto simp: L_def)
next
  fix w assume "w \<in> L"
  then obtain n where [simp]: "w = replicate n a @ replicate n b"
    by (auto simp: L_def)
  have "replicate n a @ replicate n b \<in> G"
  proof (induction n)
    case (Suc n)
    hence "a # (replicate n a @ replicate n b) @ [b] \<in> G"
      by (rule G.intros)
    thus ?case by (simp add: replicate_append_same)
  qed (auto intro: G.intros)
  thus "w \<in> G" by simp
qed

end
